#pragma once
#include <SHA256.h>
#include "mbed.h"

class EntropyPool: protected SHA256 {
public:
    EntropyPool();
    
    int entropy() { return e; }
    
    void gather();
    
    void gatherAnalogNoise(AnalogIn& input, int entropy = 8);
    
    char* produce(int bytes);

    FunctionPointer gatherer;
    
protected:
    Timer  timer;
    int    e;
};